unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite;

type
  TKostka=class(TSprite)
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Draw;override;
    procedure Move(const MoveCount:single);override;
  end;

  TRoslina=class(TKostka)
    k,
    w:integer;  //kolumna i wiersz zaczepienia pnia rosliny
   protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Move(const MoveCount:single);override;
    procedure onCollision(const Sprite:Tsprite;const colX,colY:integer);override;
  end;

  TGracz=class(TSprite)
  public
    fPokryty,
    fKolizja:boolean;
    StareX,
    StareY:single;
    kD,wD,
    k,w:integer;//indeks kolumny i wiersza
    function  Pokryty(x0,y0,_width,_height:single):boolean;
    procedure JakaKostka;
    procedure MoznaIsc;
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );
     procedure Move(const MoveCount:single);override;
     procedure Draw;override;
  end;

  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure TworzSwiat;
  public
    { Public declarations }
  end;

var
  SkokX,
  SkokY   :single;
  Form1   : TForm1;
  Warstwa0,
  Warstwa1:array[0..19,0..19]of TKostka;//przyjety rozmiar swiata 20x20 kostek
  Gracz   :TGracz;
  Roslina :TRoslina;
  Drogi   :array of  array of integer;

implementation
uses swiatUnit2;
{$R *.DFM}
//*******BLOK KOSTEK WIATA*****************************
constructor TKostka.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;
procedure TKostka.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 x:=x+SkokX;
 y:=y+SkokY;
end;
procedure TKostka.Draw;
begin
 if ImageIndex<0 then exit;
 inherited Draw;
end;
//*******KONIEC BLOKU KOSTEK WIATA*********************
//*******BLOK KLASY ROSLINA*****************************
constructor TRoslina.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent,ImageListItem,IdKlatka);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;

procedure TRoslina.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 //przykad bardzo prostej metody usuwania testu kolizji
 if (k=TGracz(Gracz).k)
    and
    (w-TGracz(Gracz).w<=2)
     then
    DoCollision:=true else
    DoCollision:=false;
end;
procedure TRoslina.onCollision(const Sprite:Tsprite;const colX,colY:integer);
var
  stareX,
  stareY:single;
begin
  if (Sprite is TGracz)then
  begin
    TGracz(Sprite).fKolizja:=true;
    TGracz(Sprite).fPokryty:=TGracz(Sprite).Pokryty(x,y,Image.TileWidth,Image.TileHeight);
    if TGracz(Sprite).fPokryty then TGracz(Sprite).Z:=z+1;
  end;
end;
//*******KONIEC BLOKU ROSLINA***************************
//*******BLOK KLASY GRACZ*******************************
procedure TGracz.JakaKostka;
begin
 //policz kol i wiersz w tablicy drog
 kd:=Round(x-Warstwa0[0,0].x+Image.TileWidth  div 2) div 32;
 wd:=Round(y-Warstwa0[0,0].y+Image.TileHeight div 2) div 32;
 if kd<0 then kd:=0;
 if kd>High(Drogi[0]) then kd:=high(drogi[0]);
 if wd<0 then wd:=0;
 if wd>High(Drogi) then wd:=high(drogi);

 //policz kol i wiersz w swiecie warstw i wyznacz Z
 k:=Round(x-Warstwa0[0,0].x+Image.TileWidth  div 2)div Warstwa0[0,0].Image.TileWidth;
 w:=Round(y-Warstwa0[0,0].y+Image.TileHeight div 2)div Warstwa0[0,0].Image.TileHeight;

 if k< 0 then k:=0;
 if k>19 then k:=19;
 if w< 0 then w:=0;
 if w>19 then w:=19;
 z:=w+3;
end;

procedure TGracz.MoznaIsc;
begin
 //Sterowanie Graczem
 stareX:=x;
 stareY:=y;
 if oisUp in Form1.OmegaInput1.keyboard.states    then//idz do gory
    SkokY:=SkokY+1;
 if oisDown in Form1.OmegaInput1.keyboard.states  then//idz w d
    SkokY:=SkokY-1;
 if oisRight in Form1.OmegaInput1.keyboard.states then//idz w prawo
    SkokX:=SkokX-1;
 if oisLeft in Form1.OmegaInput1.keyboard.states  then//idz w lewo
    SkokX:=SkokX+1;

 x:=x-SkokX;
 y:=y-SkokY;
 JakaKostka;
 //sprwdz czy mona byc w nowej pozycji jak nie to zeruj skok
 if(Drogi[wd,kd]>-1)
  then begin
    SkokX:=0;//
    SkokY:=0;//
 end;
//ustwa gracza w starej pozycji
 x:=stareX;
 y:=stareY;
end;

procedure TGracz.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 //tu mozna doda rozne inne zdarzenia zwiazane na przykald
 //ze zmian prdkoci ruchu itp. 
end;

function  TGracz.Pokryty(x0,y0,_width,_height:single):boolean;
begin
 result:=false;
 if (x>X0)and
    (y+12>y0)and
    (x+Image.TileWidth<x0+_width)and
    (y+Image.TileHeight<y0+_height)
    then result:=true;
end;

procedure TGracz.Draw;
begin
 if not fPokryty then inherited Draw
 else
 Image.Draw(Round(x),Round(y),0,0.5,0.5,1,1,255,0,255{255,255},155,ImageIndex,0);
 //Form1.OmegaFont1.Print(Round(x),Round(y),'kd:= '+IntToStr(kd)+'; wd:= '+IntToStr(wd));
 //Form1.OmegaFont1.Print(Round(x),Round(y)+20,'Droga:= '+IntToStr(Drogi[wd,kd]));
end;
constructor TGracz.Create(const AParent: TOmegaSprite;
                          const ImageListItem: TImageListItem;
                          const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image        := ImageListItem;
 ImageIndex   :=idKlatka;
 width        :=Image.TileWidth;
 height       :=Image.TileHeight;
 DoCollision  :=true;
 DoPixelCheck :=true;
end;
//*******KONIEC BLOKU KLASY GRACZ***********************
procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
    OmegaScreen1.ToggleFullScreen;
 Gracz.MoznaIsc;
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;

 OmegaSprite1.Collision;
 OmegaSprite1.Dead;
 OmegaSprite1.Draw;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs);



 OmegaFont1.Print(0,20, 'F2 zmiana trybu wywietlania aplikacji');
 OmegaFont1.Print(0,40,'FPS: '+IntToStr(OmegaTimer1.FPS));

 if Gracz.fKolizja then
 OmegaFont1.Print(0,60,'Kolizja');

 OmegaScreen1.EndRender;

 SkokX:=0;
 SkokY:=0;
 //czy flagi kolizji i pokrycia
 Gracz.fKolizja:=false;
 Gracz.fPokryty:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',8,[]);
  OmegaFont1.Color:=OmegaColor(255,0,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
  Drogi:=nil;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 TworzSwiat;
 OmegaTimer1.Enabled:=true;
end;
procedure TForm1.TworzSwiat;
const
 las:array[0..14]of integer=
    (-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     2,
     3,
     4,
     5,
     6
     );
var
 wD,kD,     //wspolrzedne pnia w siatce Drog
 RozX,RozY, //Rozmiar tablicy siatki Drog
 k,w,idObraz:integer;
begin
  //buduj tablice drog
  Drogi:=nil;
  RozX:=(OmegaImageList1.ImageList.Items[0].TileWidth  div 32)*20;
  RozY:=(OmegaImageList1.ImageList.Items[0].TileHeight div 32)*20;
  SetLength(Drogi,RozY,RozX);
  for w:=0 to rozY-1 do
    for k:=0 to rozX- 1do
     Drogi[w,k]:=-1;//wypenij indeksem wolnych pol

 Randomize;
 //tworz mape swiata
 for w:=0 to high(Warstwa0)do
 for k:=0 to high(Warstwa0[0])do begin
     //wartswa gruntu
     Warstwa0[w,k]:=TKostka.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[0],0{MapaWarstwa0[w,k]//to uyjemy w czsci trzeciej});
     Warstwa0[w,k].x:=k*OmegaImageList1.ImageList.Items[0].TileWidth;
     Warstwa0[w,k].y:=w*OmegaImageList1.ImageList.Items[0].TileHeight;
     Warstwa0[w,k].z:=w;
     Warstwa0[w,k].DoCollision :=false;
     Warstwa0[w,k].DoPixelCheck:=false;
     //tworz losowo drzewa
     if MapaWarstwa0[w,k]=0 then begin
        idObraz:=las[RAndom(high(las))];
        if idObraz>-1 then begin
         Roslina:=TRoslina.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[idObraz],0);
         Roslina.x:=k*OmegaImageList1.ImageList.Items[0].TileWidth+
                     (OmegaImageList1.ImageList.Items[0].TileWidth-Roslina.Image.TileWidth)div 2+16;//wyjustuj o 16 wzgledem tablicy Drogi;
         Roslina.y:=w*OmegaImageList1.ImageList.Items[0].TileHeight-(Roslina.Image.TileHeight-OmegaImageList1.ImageList.Items[0].TileHeight);
         Roslina.z:=w+2;
         //zapamietaj kolumne i wiersz zaczepienia rosliny
         Roslina.k:=k;
         Roslina.w:=w;
         Roslina.DoCollision :=false;
         Roslina.DoPixelCheck:=true;
         kD:=(k*OmegaImageList1.ImageList.Items[0].TileWidth+OmegaImageList1.ImageList.Items[0].TileWidth div 2) div 32;
         wD:=(w*OmegaImageList1.ImageList.Items[0].TileHeight)div 32;
         Drogi[wD,kD]:=idObraz;
        end;
     end;
 end;
 Gracz:=TGracz.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[1],0);
 Gracz.X:=96;
 Gracz.Y:=64;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#27 then close;
end;

end.
